AWS IoT Device SDK C++ v2: Aws::Crt::Io::Uri Class Reference

AWS IoT Device SDK C++ v2 1.14.0 AWS IoT Device SDK C++ v2

Public Member Functions | List of all members
Aws::Crt::Io::Uri Class Referencefinal

`#include <Uri.h>`

## Public Member Functions
| Uri () noexcept
| ~Uri ()
| Uri (const ByteCursor &cursor, Allocator *allocator=g_allocator) noexcept
| Uri (aws_uri_builder_options &builderOptions, Allocator *allocator=g_allocator) noexcept
| Uri (const Uri &)
Uri & | operator= (const Uri &)
| Uri (Uri &&uri) noexcept
Uri & | operator= (Uri &&) noexcept
| operator bool () const noexcept
int | LastError () const noexcept
ByteCursor | GetScheme () const noexcept
ByteCursor | GetAuthority () const noexcept
ByteCursor | GetPath () const noexcept
ByteCursor | GetQueryString () const noexcept
ByteCursor | GetHostName () const noexcept
uint16_t | GetPort () const noexcept
ByteCursor | GetPathAndQuery () const noexcept
ByteCursor | GetFullUri () const noexcept

## Detailed Description

Contains a URI used for networking application protocols. This type is move-only.

## Constructor & Destructor Documentation

## ◆ Uri() [1/5]

Aws::Crt::Io::Uri::Uri | ( |  | ) |
| noexcept

## ◆ ~Uri()

Aws::Crt::Io::Uri::~Uri | ( |  | ) |

## ◆ Uri() [2/5]

Aws::Crt::Io::Uri::Uri | ( | const ByteCursor & | cursor,
|  | Allocator * | allocator = `g_allocator`
| ) |  |
| noexcept

Parses `cursor` as a URI. Upon failure the bool() operator will return false and LastError() will contain the errorCode.

## ◆ Uri() [3/5]

Aws::Crt::Io::Uri::Uri | ( | aws_uri_builder_options & | builderOptions,
|  | Allocator * | allocator = `g_allocator`
| ) |  |
| noexcept

Builds a URI from `builderOptions`. Upon failure the bool() operator will return false and LastError() will contain the errorCode.

## ◆ Uri() [4/5]

Aws::Crt::Io::Uri::Uri | ( | const Uri & | other | ) |

## ◆ Uri() [5/5]

Aws::Crt::Io::Uri::Uri | ( | Uri && | uri | ) |
| noexcept

## Member Function Documentation

## ◆ GetAuthority()

ByteCursor Aws::Crt::Io::Uri::GetAuthority | ( |  | ) | const
| noexcept

Returns
  the authority portion of the URI if present. This will contain host name and port if specified.

## ◆ GetFullUri()

ByteCursor Aws::Crt::Io::Uri::GetFullUri | ( |  | ) | const
| noexcept

Returns
  The full URI as it was passed to or parsed from the constructors.

## ◆ GetHostName()

ByteCursor Aws::Crt::Io::Uri::GetHostName | ( |  | ) | const
| noexcept

Returns
  the host name portion of the authority. (port will not be in this value).

## ◆ GetPath()

ByteCursor Aws::Crt::Io::Uri::GetPath | ( |  | ) | const
| noexcept

Returns
  the path portion of the URI. If no path was present, this will be set to '/'.

## ◆ GetPathAndQuery()

ByteCursor Aws::Crt::Io::Uri::GetPathAndQuery | ( |  | ) | const
| noexcept

Returns
  the Path and Query portion of the URI. In the case of Http, this likely the value for the URI parameter.

## ◆ GetPort()

uint16_t Aws::Crt::Io::Uri::GetPort | ( |  | ) | const
| noexcept

Returns
  the port portion of the authority if a port was specified. If it was not, this will be set to 0. In that case, it is your responsibility to determine the correct port based on the protocol you're using.

## ◆ GetQueryString()

ByteCursor Aws::Crt::Io::Uri::GetQueryString | ( |  | ) | const
| noexcept

Returns
  the query string portion of the URI if present.

## ◆ GetScheme()

ByteCursor Aws::Crt::Io::Uri::GetScheme | ( |  | ) | const
| noexcept

Returns
  the scheme portion of the URI if present (e.g. https, http, ftp etc....)

## ◆ LastError()

int Aws::Crt::Io::Uri::LastError | ( |  | ) | const
| inlinenoexcept

Returns
  the value of the last aws error encountered by operations on this instance.

## ◆ operator bool()

Aws::Crt::Io::Uri::operator bool | ( |  | ) | const
| inlinenoexcept

Returns
  true if the instance is in a valid state, false otherwise.

## ◆ operator=() [1/2]

Uri & Aws::Crt::Io::Uri::operator= | ( | const Uri & | other | ) |

## ◆ operator=() [2/2]

Uri & Aws::Crt::Io::Uri::operator= | ( | Uri && | uri | ) |
| noexcept

The documentation for this class was generated from the following files:

- crt/aws-crt-cpp/include/aws/crt/io/Uri.h
- crt/aws-crt-cpp/source/io/Uri.cpp